#include "validate_0005fjava.h"
#include "validate.h"
#include <stdlib.h>

JNIEXPORT jint JNICALL Java_validate_1java_validate
(JNIEnv *env, jclass cls, jstring xml_str, jstring schema){
  int rc;

  char *c_xml_str;
  char *c_schema;

  char errbuf[128];

  jclass ExceptionClass;

  c_xml_str = (char *)(*env)->GetStringUTFChars(env,xml_str,0);
  c_schema = (char *)(*env)->GetStringUTFChars(env,schema,0);

  rc = validate_xml(c_xml_str,c_schema,errbuf,128);

  (*env)->ReleaseStringUTFChars(env,xml_str,c_xml_str);
  (*env)->ReleaseStringUTFChars(env,schema,c_schema);

  if (rc == -1){
    ExceptionClass = (*env)->FindClass(env,"ValidationException");
    (*env)->ThrowNew(env,ExceptionClass,errbuf);
  }

  return rc;
}

